package com.lightinit.hsdatashow.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StWaterRiverExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public StWaterRiverExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRiverTypeIsNull() {
            addCriterion("river_type is null");
            return (Criteria) this;
        }

        public Criteria andRiverTypeIsNotNull() {
            addCriterion("river_type is not null");
            return (Criteria) this;
        }

        public Criteria andRiverTypeEqualTo(String value) {
            addCriterion("river_type =", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeNotEqualTo(String value) {
            addCriterion("river_type <>", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeGreaterThan(String value) {
            addCriterion("river_type >", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeGreaterThanOrEqualTo(String value) {
            addCriterion("river_type >=", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeLessThan(String value) {
            addCriterion("river_type <", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeLessThanOrEqualTo(String value) {
            addCriterion("river_type <=", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeLike(String value) {
            addCriterion("river_type like", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeNotLike(String value) {
            addCriterion("river_type not like", value, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeIn(List<String> values) {
            addCriterion("river_type in", values, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeNotIn(List<String> values) {
            addCriterion("river_type not in", values, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeBetween(String value1, String value2) {
            addCriterion("river_type between", value1, value2, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverTypeNotBetween(String value1, String value2) {
            addCriterion("river_type not between", value1, value2, "riverType");
            return (Criteria) this;
        }

        public Criteria andRiverNameIsNull() {
            addCriterion("river_name is null");
            return (Criteria) this;
        }

        public Criteria andRiverNameIsNotNull() {
            addCriterion("river_name is not null");
            return (Criteria) this;
        }

        public Criteria andRiverNameEqualTo(String value) {
            addCriterion("river_name =", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameNotEqualTo(String value) {
            addCriterion("river_name <>", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameGreaterThan(String value) {
            addCriterion("river_name >", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameGreaterThanOrEqualTo(String value) {
            addCriterion("river_name >=", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameLessThan(String value) {
            addCriterion("river_name <", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameLessThanOrEqualTo(String value) {
            addCriterion("river_name <=", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameLike(String value) {
            addCriterion("river_name like", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameNotLike(String value) {
            addCriterion("river_name not like", value, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameIn(List<String> values) {
            addCriterion("river_name in", values, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameNotIn(List<String> values) {
            addCriterion("river_name not in", values, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameBetween(String value1, String value2) {
            addCriterion("river_name between", value1, value2, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverNameNotBetween(String value1, String value2) {
            addCriterion("river_name not between", value1, value2, "riverName");
            return (Criteria) this;
        }

        public Criteria andRiverCodeIsNull() {
            addCriterion("river_code is null");
            return (Criteria) this;
        }

        public Criteria andRiverCodeIsNotNull() {
            addCriterion("river_code is not null");
            return (Criteria) this;
        }

        public Criteria andRiverCodeEqualTo(String value) {
            addCriterion("river_code =", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeNotEqualTo(String value) {
            addCriterion("river_code <>", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeGreaterThan(String value) {
            addCriterion("river_code >", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeGreaterThanOrEqualTo(String value) {
            addCriterion("river_code >=", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeLessThan(String value) {
            addCriterion("river_code <", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeLessThanOrEqualTo(String value) {
            addCriterion("river_code <=", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeLike(String value) {
            addCriterion("river_code like", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeNotLike(String value) {
            addCriterion("river_code not like", value, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeIn(List<String> values) {
            addCriterion("river_code in", values, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeNotIn(List<String> values) {
            addCriterion("river_code not in", values, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeBetween(String value1, String value2) {
            addCriterion("river_code between", value1, value2, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverCodeNotBetween(String value1, String value2) {
            addCriterion("river_code not between", value1, value2, "riverCode");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionIsNull() {
            addCriterion("river_description is null");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionIsNotNull() {
            addCriterion("river_description is not null");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionEqualTo(String value) {
            addCriterion("river_description =", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionNotEqualTo(String value) {
            addCriterion("river_description <>", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionGreaterThan(String value) {
            addCriterion("river_description >", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("river_description >=", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionLessThan(String value) {
            addCriterion("river_description <", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionLessThanOrEqualTo(String value) {
            addCriterion("river_description <=", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionLike(String value) {
            addCriterion("river_description like", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionNotLike(String value) {
            addCriterion("river_description not like", value, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionIn(List<String> values) {
            addCriterion("river_description in", values, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionNotIn(List<String> values) {
            addCriterion("river_description not in", values, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionBetween(String value1, String value2) {
            addCriterion("river_description between", value1, value2, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverDescriptionNotBetween(String value1, String value2) {
            addCriterion("river_description not between", value1, value2, "riverDescription");
            return (Criteria) this;
        }

        public Criteria andRiverLengthIsNull() {
            addCriterion("river_length is null");
            return (Criteria) this;
        }

        public Criteria andRiverLengthIsNotNull() {
            addCriterion("river_length is not null");
            return (Criteria) this;
        }

        public Criteria andRiverLengthEqualTo(BigDecimal value) {
            addCriterion("river_length =", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthNotEqualTo(BigDecimal value) {
            addCriterion("river_length <>", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthGreaterThan(BigDecimal value) {
            addCriterion("river_length >", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("river_length >=", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthLessThan(BigDecimal value) {
            addCriterion("river_length <", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("river_length <=", value, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthIn(List<BigDecimal> values) {
            addCriterion("river_length in", values, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthNotIn(List<BigDecimal> values) {
            addCriterion("river_length not in", values, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("river_length between", value1, value2, "riverLength");
            return (Criteria) this;
        }

        public Criteria andRiverLengthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("river_length not between", value1, value2, "riverLength");
            return (Criteria) this;
        }

        public Criteria andStartStopPointIsNull() {
            addCriterion("start_stop_point is null");
            return (Criteria) this;
        }

        public Criteria andStartStopPointIsNotNull() {
            addCriterion("start_stop_point is not null");
            return (Criteria) this;
        }

        public Criteria andStartStopPointEqualTo(String value) {
            addCriterion("start_stop_point =", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointNotEqualTo(String value) {
            addCriterion("start_stop_point <>", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointGreaterThan(String value) {
            addCriterion("start_stop_point >", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointGreaterThanOrEqualTo(String value) {
            addCriterion("start_stop_point >=", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointLessThan(String value) {
            addCriterion("start_stop_point <", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointLessThanOrEqualTo(String value) {
            addCriterion("start_stop_point <=", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointLike(String value) {
            addCriterion("start_stop_point like", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointNotLike(String value) {
            addCriterion("start_stop_point not like", value, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointIn(List<String> values) {
            addCriterion("start_stop_point in", values, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointNotIn(List<String> values) {
            addCriterion("start_stop_point not in", values, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointBetween(String value1, String value2) {
            addCriterion("start_stop_point between", value1, value2, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andStartStopPointNotBetween(String value1, String value2) {
            addCriterion("start_stop_point not between", value1, value2, "startStopPoint");
            return (Criteria) this;
        }

        public Criteria andFlowThroughIsNull() {
            addCriterion("flow_through is null");
            return (Criteria) this;
        }

        public Criteria andFlowThroughIsNotNull() {
            addCriterion("flow_through is not null");
            return (Criteria) this;
        }

        public Criteria andFlowThroughEqualTo(String value) {
            addCriterion("flow_through =", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughNotEqualTo(String value) {
            addCriterion("flow_through <>", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughGreaterThan(String value) {
            addCriterion("flow_through >", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughGreaterThanOrEqualTo(String value) {
            addCriterion("flow_through >=", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughLessThan(String value) {
            addCriterion("flow_through <", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughLessThanOrEqualTo(String value) {
            addCriterion("flow_through <=", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughLike(String value) {
            addCriterion("flow_through like", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughNotLike(String value) {
            addCriterion("flow_through not like", value, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughIn(List<String> values) {
            addCriterion("flow_through in", values, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughNotIn(List<String> values) {
            addCriterion("flow_through not in", values, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughBetween(String value1, String value2) {
            addCriterion("flow_through between", value1, value2, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andFlowThroughNotBetween(String value1, String value2) {
            addCriterion("flow_through not between", value1, value2, "flowThrough");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageIsNull() {
            addCriterion("river_impoundage is null");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageIsNotNull() {
            addCriterion("river_impoundage is not null");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageEqualTo(BigDecimal value) {
            addCriterion("river_impoundage =", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageNotEqualTo(BigDecimal value) {
            addCriterion("river_impoundage <>", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageGreaterThan(BigDecimal value) {
            addCriterion("river_impoundage >", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("river_impoundage >=", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageLessThan(BigDecimal value) {
            addCriterion("river_impoundage <", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageLessThanOrEqualTo(BigDecimal value) {
            addCriterion("river_impoundage <=", value, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageIn(List<BigDecimal> values) {
            addCriterion("river_impoundage in", values, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageNotIn(List<BigDecimal> values) {
            addCriterion("river_impoundage not in", values, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("river_impoundage between", value1, value2, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverImpoundageNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("river_impoundage not between", value1, value2, "riverImpoundage");
            return (Criteria) this;
        }

        public Criteria andRiverChiefIsNull() {
            addCriterion("river_chief is null");
            return (Criteria) this;
        }

        public Criteria andRiverChiefIsNotNull() {
            addCriterion("river_chief is not null");
            return (Criteria) this;
        }

        public Criteria andRiverChiefEqualTo(String value) {
            addCriterion("river_chief =", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefNotEqualTo(String value) {
            addCriterion("river_chief <>", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefGreaterThan(String value) {
            addCriterion("river_chief >", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefGreaterThanOrEqualTo(String value) {
            addCriterion("river_chief >=", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefLessThan(String value) {
            addCriterion("river_chief <", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefLessThanOrEqualTo(String value) {
            addCriterion("river_chief <=", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefLike(String value) {
            addCriterion("river_chief like", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefNotLike(String value) {
            addCriterion("river_chief not like", value, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefIn(List<String> values) {
            addCriterion("river_chief in", values, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefNotIn(List<String> values) {
            addCriterion("river_chief not in", values, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefBetween(String value1, String value2) {
            addCriterion("river_chief between", value1, value2, "riverChief");
            return (Criteria) this;
        }

        public Criteria andRiverChiefNotBetween(String value1, String value2) {
            addCriterion("river_chief not between", value1, value2, "riverChief");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNull() {
            addCriterion("water_level_normal is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNotNull() {
            addCriterion("water_level_normal is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalEqualTo(BigDecimal value) {
            addCriterion("water_level_normal =", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <>", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThan(BigDecimal value) {
            addCriterion("water_level_normal >", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal >=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThan(BigDecimal value) {
            addCriterion("water_level_normal <", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIn(List<BigDecimal> values) {
            addCriterion("water_level_normal in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotIn(List<BigDecimal> values) {
            addCriterion("water_level_normal not in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal not between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNull() {
            addCriterion("water_level_warning is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNotNull() {
            addCriterion("water_level_warning is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningEqualTo(BigDecimal value) {
            addCriterion("water_level_warning =", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <>", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThan(BigDecimal value) {
            addCriterion("water_level_warning >", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning >=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThan(BigDecimal value) {
            addCriterion("water_level_warning <", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIn(List<BigDecimal> values) {
            addCriterion("water_level_warning in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotIn(List<BigDecimal> values) {
            addCriterion("water_level_warning not in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning not between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNull() {
            addCriterion("water_level_dead is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNotNull() {
            addCriterion("water_level_dead is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadEqualTo(BigDecimal value) {
            addCriterion("water_level_dead =", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <>", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThan(BigDecimal value) {
            addCriterion("water_level_dead >", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead >=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThan(BigDecimal value) {
            addCriterion("water_level_dead <", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIn(List<BigDecimal> values) {
            addCriterion("water_level_dead in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotIn(List<BigDecimal> values) {
            addCriterion("water_level_dead not in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead not between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNull() {
            addCriterion("water_quality is null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNotNull() {
            addCriterion("water_quality is not null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityEqualTo(String value) {
            addCriterion("water_quality =", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotEqualTo(String value) {
            addCriterion("water_quality <>", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThan(String value) {
            addCriterion("water_quality >", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThanOrEqualTo(String value) {
            addCriterion("water_quality >=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThan(String value) {
            addCriterion("water_quality <", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThanOrEqualTo(String value) {
            addCriterion("water_quality <=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLike(String value) {
            addCriterion("water_quality like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotLike(String value) {
            addCriterion("water_quality not like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIn(List<String> values) {
            addCriterion("water_quality in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotIn(List<String> values) {
            addCriterion("water_quality not in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityBetween(String value1, String value2) {
            addCriterion("water_quality between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotBetween(String value1, String value2) {
            addCriterion("water_quality not between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(String value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(String value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(String value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(String value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(String value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(String value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLike(String value) {
            addCriterion("deleted_by like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotLike(String value) {
            addCriterion("deleted_by not like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<String> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<String> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(String value1, String value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(String value1, String value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}